"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
/**
 * The UpdateChannelInvitationPreferenceData model module.
 * @module model/UpdateChannelInvitationPreferenceData
 * @version 0.0.16
 */
var UpdateChannelInvitationPreferenceData = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>UpdateChannelInvitationPreferenceData</code>.
   * @alias module:model/UpdateChannelInvitationPreferenceData
   * @param autoAccept {Boolean} Determines for the user whether or not to automatically join a [private](/docs/chat/v3/platform-api/guides/group-channel#-3-private-vs-public) group channel promptly from an invitation without having to accept it. (Default: true)
   */
  function UpdateChannelInvitationPreferenceData(autoAccept) {
    _classCallCheck(this, UpdateChannelInvitationPreferenceData);
    UpdateChannelInvitationPreferenceData.initialize(this, autoAccept);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(UpdateChannelInvitationPreferenceData, null, [{
    key: "initialize",
    value: function initialize(obj, autoAccept) {
      obj['auto_accept'] = autoAccept;
    }

    /**
     * Constructs a <code>UpdateChannelInvitationPreferenceData</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/UpdateChannelInvitationPreferenceData} obj Optional instance to populate.
     * @return {module:model/UpdateChannelInvitationPreferenceData} The populated <code>UpdateChannelInvitationPreferenceData</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new UpdateChannelInvitationPreferenceData();
        if (data.hasOwnProperty('auto_accept')) {
          obj['auto_accept'] = _ApiClient["default"].convertToType(data['auto_accept'], 'Boolean');
        }
      }
      return obj;
    }
  }]);
  return UpdateChannelInvitationPreferenceData;
}();
/**
 * Determines for the user whether or not to automatically join a [private](/docs/chat/v3/platform-api/guides/group-channel#-3-private-vs-public) group channel promptly from an invitation without having to accept it. (Default: true)
 * @member {Boolean} auto_accept
 */
UpdateChannelInvitationPreferenceData.prototype['auto_accept'] = undefined;
var _default = UpdateChannelInvitationPreferenceData;
exports["default"] = _default;